.org 0x100

.equ Enter, 0x0A
.equ CR   , 0x0D

.equ KanalNummer, 0x60

.org 0x100
  ; Interrupts sperren
  mov 0xA8,#0x00 ; IEN0-Register

Hauptschleife:

  Lesen: jnb RI,Lesen
  mov a,SBUF
  clr RI

  lcall ChangeKanal
  jnz Hauptschleife

  ; Messung starten
  mov 0xDA,#0x00 ; ADDATL-Register
  ; Warten bis Busy-Bit gelscht
  Warten: jb 0xD8.4, Warten

  ; Ergebnisse versenden  
  lcall SendErgebnis

  ljmp Hauptschleife


; =======================================================
; Kanal fr Messung whlen. Kanalnummer in a.

SetKanal:
  mov KanalNummer,a  

  ; A/D-Wandler konfigurieren
  mov 0xD8,a ; ADCON0-Register
  mov 0xD9,a ; ADCON1-Register

  jnz Schleife
  mov a,#0x01
  sjmp Weiter
  Schleife:
  mov r0,a
  mov a,#0x01
  loop:
    rl a
  djnz r0,loop
  Weiter:

  push ACC

  ; RMAP einschalten
  mov a,SYSCON
  orl a,#0x10
  mov SYSCON,a

  pop ACC
  push ACC

  anl a,#0x0F
  mov P1,a ; P1ANA
  
  pop ACC
  push ACC

  anl a,#0xF0
  rr a
  rr a
  mov P3,a ; P3ANA

  ; RMAP ausschalten
  mov a,SYSCON
  anl a,#0xEF
  mov SYSCON,a

  pop ACC
  ret

; =======================================================
; Wandelt ASCII-Zeichen aus a in Zahl um und setzt den
; entsprchenden Kanal. Bei Erfolg ist a=0, sonst a=1.

ChangeKanal:
  push ACC
  clr c
  subb a,#48
  pop ACC
  jc Fehler

  push ACC
  clr c
  subb a,#56
  pop ACC
  jnc Fehler

  clr c  
  subb a,#48
  lcall SetKanal
  mov a,0x00
  ret

Fehler:
  mov a,#0x01
  ret

; =======================================================
; Byte aus a in ASCII-Code umwandeln und ber die serielle
; Schnittstelle versenden.

SendByte:
  push ACC
  anl a,#0xF0
  rr a
  rr a
  rr a
  rr a

  lcall HalbConvertToASCII

  w1: jnb TI,w1
  clr TI
  mov SBUF,a

  pop ACC
  anl a,#0x0F

  lcall HalbConvertToASCII

  w2: jnb TI,w2
  clr TI
  mov SBUF,a

  ret

HalbConvertToASCII:
  push ACC
  clr c
  subb a,#0x0A
  pop ACC
  jc ZahlToASCII
  add a,#55
  ret
ZahlToASCII:
  add a,#48
  ret

; =======================================================
; Byte aus a ber die serielle Schnittstelle versenden.

SendChar:
  w3: jnb TI,w3
  clr TI
  mov SBUF,a
  ret


; =======================================================
; Ergebnisse zurckschreiben.

SendErgebnis:

  mov a,KanalNummer
  add a,#48
  lcall SendChar

  mov a,#58 ; = ":"
  lcall SendChar

  mov a,#32 ; = " "
  lcall SendChar

  mov a,#85 ; = "U"
  lcall SendChar

  mov a,#61 ; = "="
  lcall SendChar

  mov a,0xD9 ; ADDATH-Register
  lcall SendByte

  mov a,0xDA ; ADDATL-Register
  lcall SendByte

  mov a,#Enter
  lcall SendChar

  mov a,#CR
  lcall SendChar

  ret

.end
